importScripts('./js/environment.js','./js/enums.js');

var ports = {};

// Tab data
var data = {};

//keep a record of the activeTab, in case a devtools window/tab gets focus instead.
var activeTabId;

// Configuration objects
var config = {};
var dataCollectionOptionDefault = 1;
var defaultConfig = { showGrid: false };
var flags = { addRows: 0 };

// TODO: remove this scope
var authenticationToken = null;
chrome.storage.local.clear();
// TILL HERE

chrome.runtime.onConnect.addListener(function (port) {
    let tabId = port.sender.tab.id;
    port.postMessage({ command: OTTEnums.commands.setTabId, data: { tabId: tabId } });
    // Remove from ports when tab is closed
    port.onDisconnect.addListener(function (port) {
        delete ports[port.sender.tab.id];

    });

    port.onMessage.addListener(function (msg) {
        switch (msg.command) {
            case OTTEnums.commands.oneTagFound: {
                chrome.action.setIcon({
                    path: "imgs/icon_full_48.png",
                    tabId: msg.tabId
                });
                break;
            }
        }
        return true;
    });
});

function getActiveTab(callback) {
    chrome.tabs.query({ lastFocusedWindow: true, active: true }, function (tabs) {
        var tab = tabs[0];

        if (tab) {
            callback(tab);
        } else {
            chrome.tabs.get(activeTabId, function (tab) {
                if (tab) {
                    callback(tab);
                } else {
                    console.log('No active tab identified.');
                }
            });
        }
    });
}

// Receiving messages from popup.html
chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
    getActiveTab(function (tab) {
        let tabId = tab.id;
        // Port exists means content.js is ready on page
        chrome.tabs.sendMessage(tabId, { tabId: tabId, command: request.command, data: request.data || {} }, function(response) {});
        sendResponse({status:true});
    });

    return true;
});

// get the correct active tab, even if a devtools window takes focus away
chrome.tabs.onActivated.addListener(function (activeInfo) {
    activeTabId = activeInfo.tabId;
});