var _timelineCounter = {};
var Enricher = {
	_timelineCounter: {},
	timelines: function(dataRow, tabId, callback) {
		var timelineCounterKey = "timelineCounter" + tabId;
		//chrome.storage.local.get(timelineCounterKey, function(storage) {
			//storage[timelineCounterKey] = storage[timelineCounterKey] || 0;

			_timelineCounter[tabId] = _timelineCounter[tabId] || 0;

			var enriched = {
		        "index": _timelineCounter[tabId]++, //storage[timelineCounterKey],
		        "id": dataRow.id,
		        "name": dataRow.name,
		        "type": dataRow.type || "-",
		        "sendTime": OTTInfra.formattedDate(dataRow.sendTime),
		        "receiveTime" : OTTInfra.formattedDate(dataRow.receiveTime),
            	"total": (dataRow.receiveTime - dataRow.sendTime) + "ms",
            	"_category": "timelines"
		    }; 
        	//storage[timelineCounterKey]++;
        	//chrome.storage.local.set(storage);

        callback(null, enriched, false, dataRow);
    	//});		
	},
	conversion: function(dataRow, tabId, callback, binding) {
		var $this = this;
		OTTInfra.ajax.get.conversion(dataRow.id, function(json) {
			$this._getRuleNamesFromIds(dataRow._triggeringRuleIds, function(ruleNamesArr) {
				var parameters = $this._getRequestParams(dataRow.parameters, json.result && json.result.activityParameter);
				var parametersDisplay = "";
				for(var key in parameters) {
					parametersDisplay += key + "=" + parameters[key] + "&";
				}
				parametersDisplay = parametersDisplay.substring(0, parametersDisplay.length - 1);
				var thirdPartyTags = dataRow.thirdPartyTags || [];
	
				var enriched = {
					"id": dataRow.id,
                    "name": json.result && json.result.name || 'Requires Login',
	            	"triggeringRuleIds": dataRow._triggeringRuleIds ? (dataRow._triggeringRuleIds.length == 1 ? dataRow._triggeringRuleIds[0] : (dataRow._triggeringRuleIds.length + " rules")) : '-',
	            	"_triggeringRuleIds": dataRow._triggeringRuleIds || [],
	            	"_triggeringRuleNames": ruleNamesArr,
	            	"type": dataRow.type,
	            	"parameters": parametersDisplay || '-',
	            	"_parameters": parameters,
	            	"thirdPartyActivities": thirdPartyTags.length + " URL" + ((thirdPartyTags.length != 1) ? "s" : ""),
	            	"_thirdPartyActivities": thirdPartyTags,
	            	"pathToConversion": dataRow.pathToConversion && (dataRow.pathToConversion.length + " Records") || '-',
	            	"_pathToConversion": dataRow.pathToConversion,
                    "_advertiserId" : json.result && json.result.advertiserId || "Requires Login",
	            	"countingMethod": $this._countingMethodToTerm(dataRow.countingMethod) || '-',
	            	"_tagManagerId": dataRow.tagManagerId,
                    "status": "200 OK",
                    "_category": "conversion"
				};

                var requiresLogin = false;
                if(!(json.result && json.result.name)) {
                    requiresLogin = true;
                }

				$this._enrichPathToConversion(enriched._pathToConversion, function() {
                    callback.apply(binding, [null, enriched, requiresLogin, dataRow]);
				});

	    	});
		});

	},

	retargeting: function(dataRow, tabId, callback, binding) {
		var $this = this;

		OTTInfra.ajax.get.retargeting(dataRow.id, function(json) {
			$this._getRuleNamesFromIds(dataRow._triggeringRuleIds, function(ruleNamesArr) {

				var enriched = {
	            	"id": dataRow.id,
                    "name": json.result && json.result.name || 'Requires Login',
	            	"triggeringRuleIds": dataRow._triggeringRuleIds.length == 1 ? dataRow._triggeringRuleIds[0] : (dataRow._triggeringRuleIds.length + " rules"),
	            	"_triggeringRuleIds": dataRow._triggeringRuleIds,
	            	"_triggeringRuleNames": ruleNamesArr,
	            	"setValue": dataRow.setValue, 
                    "_advertiserId" : json.result && json.result.advertiserId || "Requires Login",
	            	"_tagManagerId": dataRow.tagManagerId,
                    "status": "200 OK",
                    "_category": "retargeting",
	        	};

                var requiresLogin = false;
                if(!(json.result && json.result.name)) {
                    requiresLogin = true;
                }

                callback.apply(binding, [null, enriched, requiresLogin, dataRow]);		
	    	});
		});
	},

	"3rdparty": function(dataRow, tabId, callback, binding) {
		var $this = this;
		OTTInfra.ajax.get.thirdParty(dataRow.id, function(json) {
			$this._getRuleNamesFromIds(dataRow._triggeringRuleIds, function(ruleNamesArr){

				var enriched = {
		            id: dataRow.id,
                    name: (json.result && json.result.name) || "Requires Login",
		            triggeringRuleIds: dataRow._triggeringRuleIds.length == 1 ? dataRow._triggeringRuleIds[0] : (dataRow._triggeringRuleIds.length + " rules"),
		            _triggeringRuleIds: dataRow._triggeringRuleIds,
		            _triggeringRuleNames: ruleNamesArr,
                    _advertiserId : json.result && json.result.advertiserId || "Requires Login",
		            _tagManagerId: dataRow.tagManagerId,
                    code: dataRow.code,
                    "_category": "3rdparty"
		        };		

                var requiresLogin = false;
                if(!(json.result && json.result.name)) {
                    requiresLogin = true;
                }	

                callback.apply(binding, [null, enriched, requiresLogin, dataRow]);	
	        });	
		});
	},

	variables: function(dataRow, tabId, callback) {

		// retargeting variable name is the retargeting id,
		// Benny wanted to change it to variable name, taken from retargeting platform json
		// if variableName is a number, we can assum it might be retargeting and attempts to get variableName defined
		// worse case, call fails and we paste the variableName given in dataRow as done in fallback handling
		if(!isNaN(parseFloat(dataRow.variableName))) {
			var $this = this;
			
			OTTInfra.ajax.get.retargeting(dataRow.variableName, function(json) {
				var enriched = {
            		"id": dataRow.id,
                    "variableName": json.result && json.result.variableName || dataRow.variableName || "Requires Login",
            		"type": $this._getVariableType(dataRow.type),
            		"nameOnPage": dataRow.path,
                    "valueOnPage": dataRow.value,
                    "_category": "variables"
        		};

                var requiresLogin = false;
                if(!(json.result && json.result.variableName || dataRow.variableName)) {
                    requiresLogin = true;
                }	

                callback(null, enriched, requiresLogin, dataRow);
        	});
        	return;
		}

		// fallback handling
		var enriched = {
            "id": dataRow.id,
            "variableName": dataRow.variableName || dataRow.path,   //server doesn't send variableName for QueryString vars
            "type": this._getVariableType(dataRow.type),
            "nameOnPage": dataRow.path,
            "valueOnPage": dataRow.value,
            "_category": "variables"
        };

        callback(null, enriched, false, dataRow);
	},

	_getVariableType: function(type) {
		switch(type.toUpperCase()) {
			case "QS":
				return "Querystring";
			case "DL":
				return "Data Layer"
			case "JS":
				return "JavaScript"
		}
		return "unknown";
	},

	// Extract parameters relevant to the activity params (filtering out any technical params and leaving only
	// data params send in this request)
	_getRequestParams: function(paramsArr, fields) {
		
		if(!paramsArr || !paramsArr.length || !fields) {
			return [];
		}

		var res = {};
		for (var i = 0;i < fields.length; i++) {
			var field = fields[i].name.toLowerCase();
			if(field) {
				for (var j = 0;j < paramsArr.length; j++) {
					// found the field
					if(field in paramsArr[j]) {
						res[fields[i].name] = paramsArr[j][field];
					}
				}
			}
		}
		
		return res;
	},

	_countingMethodToTerm: function(methodNumber) {
		switch(methodNumber) {
			case 0: {
				return "Activity Frequency Standard";
			}
			case 1: {
				return "Activity Frequency 24 hours";
			}
			case 2: {
				return "Activity Frequency Session";
			}
		}
		return null;
	},

	_getRuleNamesFromIds: (function() {

			var names = {};
 
			return function(ids, callback) {
				var res = [];
				var semaphore = 0;

            if(!ids || (ids && (ids.length == 0))) {
                callback.apply(this, [res]);
                return;
            }

				for (var i = 0;i < ids.length; i++) {
					if(names[ids[i]]) {
						res.push(names[ids[i]]);
					} else {
						semaphore++;
                }
            }

            var notFoundIds = ids.filter(r => !names[r]);

            if(notFoundIds.length == 0) {
                callback.apply(this, [res]);
                return;
            }

            for (var i = 0;i < notFoundIds.length; i++) {
						(function(id) {
							OTTInfra.ajax.get.activityRule(id, function(json) {
								semaphore--;

								var name = json.result.name;
                        if(name) {
								names[id] = name;
                            res.push(name);
                        }

								if(semaphore == 0) {
									semaphore = -1; // to avoid calling callback twice, maybe this is an overkill
									callback.apply(this, [res]);
								}
							});
                })(notFoundIds[i])
				}
			}
	})(),

	_enrichPathToConversion: function(PTCArr, callback) {
		var semaphore = 0;
		var $this = this;

		if(!PTCArr || !PTCArr.length) {
			callback.apply($this, []);
			return;
		}

        semaphore = PTCArr.length;

		for(var i = 0; i < PTCArr.length; i++) {
			var record = PTCArr[i];

			// translate AdType from numeric value to verbal
			if(typeof record["AdType"] != "undefined") {
				switch(record["AdType"]) {
					case 0: {
						record["AdType"] = "Not Set";
						break;
					}
					case 1: {
						record["AdType"] = "Impression";
						break;
					}
					case 2: {
						record["AdType"] = "Click";
						break;
					}
					case 3: {
						record["AdType"] = "Viewable";
						break;
					}
				}
			}

			// Get ad name for each ad id in records
            (function(r) {
                if(r.AdId) {
                    OTTInfra.ajax.get.ad(r.AdId, function(json) {
						semaphore--;
						try {
                            r.AdName = json.result.name || '-';
						} catch(e) {
                            r.AdName = '-';
						}
						if(semaphore == 0 && callback) {
							semaphore = -1; // to avoid calling callback twice, maybe this is an overkill
							callback.apply($this, []);
						}
					});
				} else {
					semaphore--;
				}

				if(semaphore == 0 && callback) {
					semaphore = -1; // to avoid calling callback twice, maybe this is an overkill
					callback.apply($this, []);
				}
			})(record);
		}
	}
};

