var OTTInfra = {
    qs: function (querystring) {
        // remove any preceding url and split
        querystring = querystring.substring(querystring.indexOf('?')+1).split('&');
        var params = {}, pair, d = decodeURIComponent;
        // march and parse
        for (var i = querystring.length - 1; i >= 0; i--) {
            pair = querystring[i].split('=');
            params[d(pair[0])] = d(pair[1] || '');
        }   
        return params;
    },
    getEnviroment: function() {
        return window.OTTEnv.dsDomain;
    },
    
    addDistinct: function(arr, items) {
        if(OTTInfra.isObj(items)) {
            items = [items];
        }

        if(!arr || !items || !items.length) {
            return;
        }

        for(var j = 0; j < items.length; j++) {
            var item = items[j];
            var flag = true;
            for (var i = 0; i < arr.length; i++) {
                // If item equals some other item in array, break
                if (OTTInfra.isEqual(item, arr[i])) {
                    flag = false;
                    break;
                }
            }
            if(flag) {
                arr.push(item);
            }
        }
    },

    extractDomain: function() {
        var url = window.location.href;
        var hostname = (new URL(url)).hostname;
        return hostname;
    },

    isPdf: function() {
        return window.location.href.endsWith(".pdf");
    },

    sendToGrid: function(type, data) {
        if(!this._grid) {
            $this = this;
            setTimeout(function() { $this.sendToGrid.apply($this,[msg]);}, 100);
        }

        Infra.pm({
            target: this._grid.contentWindow,
            type: type,
            data: data
        });
    },

    mergeObj: function (source, target, override) {
        override = !!override;

        for (var prop in source) {
            if (!source.hasOwnProperty(prop))
                continue;

            // we merge the property if target doesn't have it or we were told to override
            if (!target.hasOwnProperty(prop) || override)
                target[prop] = source[prop];
        }
    },

    cloneObj: function (obj, preserveElemRefs) {
        if (!EBG.isObj(obj)) {
            return null;
        }
        var cloned = {};
        for (var prop in obj) {
            if (!obj.hasOwnProperty(prop)) {
                continue;
            }
            if (preserveElemRefs && EBG.isElementOrNode(obj[prop])) {
                cloned[prop] = obj[prop];
            }
            else {
                cloned[prop] = EBG.isObj(obj[prop]) ? EBG.cloneObj(obj[prop]) : obj[prop];
            }
        }

        return cloned;
    },

    pushUnique: function (newItem, arr) {
        var foundIt = false;
        if (OTTInfra.isArray(arr)) {
            arr.forEach(function(item) {
                if (OTTInfra.isEqual(item, newItem)) {
                    foundIt = true;
                }
            });
            if (!foundIt) {
                arr.push(newItem);
            }
        }
    },

    isEqual: function(a, b) {
        if(a === b) {
            return true;
        }

        if(this.isObj(a) && this.isObj(b)) {
            return this.isObjEqual(a, b);
        }

        if(this.isArray(a) && this.isArray(b)) {
            return this.isArrayEqual(a, b);
        }

        return false;
    },

    isObjEqual: function(a, b) {        
        for(var key in a) {
            // compare only properties that doesnt start with '_' or '$'
            if(key.indexOf('_') != 0 && key.indexOf('$') != 0 && key != "index") {
                if(!this.isEqual(a[key], b[key])) {
                    return false;
                }
            }
        }

        return true;
    },

    isArrayEqual: function(a, b) {
        if (a.length != b.length) return false;

        for (var i = 0; i < a.length; ++i) {
            if (a[i] !== b[i]) return false;
        }
        return true;
    },

    typeOf: function (a) {
        var b = typeof (a);
        if (b == "object") if (a) {
            if (a instanceof Array || !(a instanceof Object) && Object.prototype.toString.call(a) == "[object Array]" || typeof a.length == "number" && typeof a.splice != "undefined" && typeof a.propertyIsEnumerable != "undefined" && !a.propertyIsEnumerable("splice")) return "array";
            if (!(a instanceof Object) && (Object.prototype.toString.call(a) == "[object Function]" || typeof a.call != "undefined" && typeof a.propertyIsEnumerable != "undefined" && !a.propertyIsEnumerable("call"))) return "function";
        }
        else if (b == "function" && typeof a.call == "undefined") { return "object"; }
        else {
            return "null";
        }
        return b;
    },

    isFunc: function (a) {
        return this.typeOf(a) == "function";
    },
    isArray: function (a) {
        return this.typeOf(a) == "array";
    },
    isObj: function (a) {
        return this.typeOf(a) == "object";
    },
    isDefined: function (a) {
        return this.typeOf(a) != "undefined";
    },
    ajax: (function () {
        var ajax = {};
        var hostname = "platform.sizmek.com"; //window.OTTEnv.platformDomain;

        ajax.x = function () {
            if (typeof XMLHttpRequest !== 'undefined') {
                return new XMLHttpRequest();
            }
            var versions = [
                "MSXML2.XmlHttp.5.0",
                "MSXML2.XmlHttp.4.0",
                "MSXML2.XmlHttp.3.0",
                "MSXML2.XmlHttp.2.0",
                "Microsoft.XmlHttp"
            ];

            var xhr;
            for (var i = 0; i < versions.length; i++) {
                try {
                    xhr = new ActiveXObject(versions[i]);
                    break;
                } catch (e) {
                }
            }
            return xhr;
        };

        ajax.post = function (url, data, headers, callback) {
            try {
                var x = ajax.x();
                x.open('POST', url, true);
                x.onreadystatechange = function () {
                    if (x.readyState == 4) {
                        callback && callback(x.responseText);
                    }
                };
                if (!headers) {
                    x.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
                } else {
                    for (var key in headers) {
                        x.setRequestHeader(key, headers[key]);
                    }
                }
                x.send(JSON.stringify(data));
            } catch (e) { }
        };

        ajax.send = function (url, callback, method, data, headers, async) {
            if (async === undefined) {
                async = true;
            }
            var x = ajax.x();
            x.open(method, url, true);
            x.onreadystatechange = function () {
                if (x.readyState == 4) {
                    callback(x.responseText, url);
                }
            };
            if (method == 'POST') {
                x.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
            }

            if(headers) {
                for(var key in headers) {
                    x.setRequestHeader(key, headers[key]);
                }
            }
            x.send(data)
        };

        ajax.get = function (url, data, headers, callback, async) {
            var query = [];
            for (var key in data) {
                query.push(encodeURIComponent(key) + '=' + encodeURIComponent(data[key]));
            }
            ajax.send(url + (query.length ? '?' + query.join('&') : ''), callback, 'GET', null, headers, async)
        };

        ajax.setHostname = function(hostname) {

            hostname = hostname;
        };

        ajax.get.conversion = function(id, callback, binding) {
            ajax.get._general(id, "rest/tagManagers/activities/conversions", callback, binding);
        };

        ajax.get.retargeting = function(id, callback, binding) {
            ajax.get._general(id, "rest/tagManagers/activities/retargeting", callback, binding);
        };

        ajax.get.thirdParty = function(id, callback, binding) {
            ajax.get._general(id, "rest/tagManagers/activities/thirdparty", callback, binding);
        };

        ajax.get.activityRule = function(id, callback, binding) {
            ajax.get._general(id, "rest/tagManagers/activityRule", callback, binding);
        };

        ajax.get.ad = function (id, callback, binding) {
            ajax.get._general(id, "rest/ads", callback, binding);
        };

        // No id is needed (vb
        ajax.get.advertiserIds = function (callback, binding) {
            ajax.get._general("advertisers?from=0&max=250", "rest", callback, binding);
        };
        /*
        data = {
            "entities": [
            {
                "type": "TagManagerVariable",
                "name": "Var12347",
                "advertiserId": "1073743371",
                "variableType": "DataLayerVariable",
                "dataType": "String",
                "variableName": "Var122"
            },
            ...
        };
        */

        ajax.get.advertiserId = function (id, callback, binding) {
            ajax.get._general(id, "rest/tagManagers", callback, binding);
        };
        
        ajax.get.variables = function (id, callback, binding) {
            let theId = "tagManagers/variables?advertiserId=" + id + "&from=0&max=250&order=asc&sort=name";
            ajax.get._general(theId, "rest", callback, binding);
        };

        ajax.post.variable = function (data, callback, binding) {
            ajax.post("https://" + hostname + "/" + "rest/tagManagers/variables/saveVariables", data, {
                "Authorization": authenticationToken,
                "Content-Type": "application/json",
                "Access-Control-Expose-Headers": "Authorization",
                "Access-Control-Allow-Methods": "GET, POST, PUT, DELETE, OPTIONS"
            }, function () {
                if (callback) {
                    callback.apply(binding || this, arguments);
                }
            });
        };

        ajax.get._general = function(id, path, callback, binding) {

            // authentication token is not necessary set by now
            // if so, continue as normal
            if(!authenticationToken) {
                console.warn("authentication token missing");
                callback.apply(binding || this, [{ error: "authentication token missing" , result: {} }])
                return;
            }

            // if someone messed up and somehow hostname undefined
            if(!hostname || !id || !path || !authenticationToken) {
                console.warn("ajax call could not be made, use ajax.setHostname before invoking any call and be sure to specify a path and id");
                callback.apply(binding || this, [{ error: "hostname not defined, ajax call could not be made" , result: {} }])
                return;
            }

            OTTInfra.ajax.get("https://" + hostname + "/" + path + "/" + id, {}, {
                "Authorization": authenticationToken,
                "Content-Type": "application/json",
                "Access-Control-Expose-Headers": "Authorization",
                "Access-Control-Allow-Methods": "GET, POST, PUT, DELETE, OPTIONS"
            }, function(json, url) {
                try {
                    json = JSON.parse(json);
                    if(json.error) {
                        throw new Exception(json.error);
                    }
                    callback.apply(binding || this, [json]);
                } catch(e) {
                    console.error("Request to server failed with error: " + e && e.message ? e.message : e);
                    callback.apply(binding || this, [{ error: e, result: {} }]);
                }
            });
        }

        return ajax;
    })(),
    formattedDate: function(time) {
        var date = new Date(time);
        var str = date.getFullYear() + "-" + (date.getMonth() + 1) + "-" + date.getDate() + " " +  date.getHours() + ":" + date.getMinutes() + ":" + date.getSeconds();
        return str;
    }
};

(function(a,t,e){t.extend=function(){for(var a=arguments[0],t=1,e=arguments.length;e>t;t++){var n=arguments[t];for(var s in n)a[s]=n[s]}return a},t.pm=function(a){n.send(a)},t.pm.bind=function(a,t,e,s,r){n.bind(a,t,e,s,r)},t.pm.unbind=function(a,t){n.unbind(a,t)},t.pm.dispatch=function(a,t,e,s){n._dispatch({data:JSON.stringify({data:t,type:a}),source:e,target:s,origin:null})},t.pm.origin=null;var n={send:function(a){var e=t.extend({},n.defaults,a),s=e.target;if(e.target&&e.type){var r={data:e.data,type:e.type};e.success&&(r.callback=n._callback(e.success)),e.error&&(r.errback=n._callback(e.error)),"postMessage"in s&&!e.hash&&(n._bind(),s.postMessage(JSON.stringify(r),e.origin||"*"))}},bind:function(e,s,r,i,d,c){if("postMessage"in a&&!c){n._bind(i);var o=n.data("listeners.postmessage");o||(o={},n.data("listeners.postmessage",o));var l=o[e];l||(l=[],o[e]=l),l.push({fn:s,origin:d||t.pm.origin,bindObj:r})}},unbind:function(a,t){var e=n.data("listeners.postmessage");if(e)if(a)if(t){var s=e[a];if(s){for(var r=[],i=0,d=s.length;d>i;i++){var c=s[i];c.fn!==t&&r.push(c)}e[a]=r}}else delete e[a];else e={}},data:function(a,t){return t===e?n._data[a]:(n._data[a]=t,t)},_data:{},_CHARS:"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split(""),_random:function(){for(var a=[],t=0;32>t;t++)a[t]=n._CHARS[0|32*Math.random()];return a.join("")},_callback:function(a){var t=n.data("callbacks.postmessage");t||(t={},n.data("callbacks.postmessage",t));var e=n._random();return t[e]=a,e},_bind:function(t){n.data("listening.postmessage")||(t=t?t:a,t.addEventListener?t.addEventListener("message",n._dispatch,!1):a.attachEvent&&t.attachEvent("onmessage",n._dispatch),n.data("listening.postmessage",1))},_dispatch:function(a){var t={};try{t=JSON.parse(a.data)}catch(e){return}if(t.type){var s=n.data("callbacks.postmessage")||{},r=s[t.type];if(r)r(t.data);else for(var i=n.data("listeners.postmessage")||{},d=i[t.type]||[],c=0,o=d.length;o>c;c++){var l=d[c];if(l.origin&&a.origin!==l.origin){if(t.errback){var g={message:"postmessage origin mismatch",origin:[a.origin,l.origin]};n.send({target:a.source,data:g,type:t.errback})}}else try{var u;u=l.bindObj?l.fn.apply(l.bindObj,[t.data,a]):l.fn(t.data,a),t.callback&&n.send({target:a.source,data:u,type:t.callback})}catch(e){t.errback&&n.send({target:a.source,data:e,type:t.errback})}}}}};t.extend(n,{defaults:{target:null,url:null,type:null,data:null,success:null,error:null,origin:"*",hash:!1}})})(this,OTTInfra);
